"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var Excel = require("xlsx");
var core_services_date_service_1 = require("../../../core/services/date/core-services-date.service");
var Core = (function () {
    function Core() {
        this.status$ = new rxjs_1.Subject();
    }
    Core.saveFile = function (content, sheetName, _fileName) {
        if (_fileName === void 0) { _fileName = null; }
        return __awaiter(this, void 0, void 0, function () {
            var currentDate, fileName, fileNameWidthDate, ws, wb;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        currentDate = core_services_date_service_1.DateGet.customDate(new Date().toISOString(), 'YYYYMMDD_HHMMss');
                        fileName = _fileName == null ? "Export " + currentDate : "" + _fileName;
                        fileNameWidthDate = fileName + " " + currentDate + ".xlsx";
                        ws = Excel.utils.json_to_sheet(content);
                        wb = Excel.utils.book_new();
                        Excel.utils.book_append_sheet(wb, ws, sheetName);
                        return [4, Excel.writeFile(wb, fileNameWidthDate, { cellStyles: true })];
                    case 1:
                        _a.sent();
                        exports.ExportExcelCore.clearSubject();
                        return [2, { code: 200, message: 'File saved successfully' }];
                }
            });
        });
    };
    Core.prototype.exportDatabase = function (userData, sheetName, fileName, firstSheet) {
        var _this = this;
        if (firstSheet === void 0) { firstSheet = true; }
        this.status$.next('Criando planilha do Excel...');
        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, Core.saveFile(userData, sheetName, fileName)];
                    case 1:
                        result = _a.sent();
                        this.status$.next(result.message);
                        if (result.code === 200) {
                            resolve(result.message);
                        }
                        else {
                            throw new Error(result.message);
                        }
                        return [2];
                }
            });
        }); });
    };
    Core.prototype.clearSubject = function () {
        this.status$.observers.map(function (x) { return x.complete(); });
    };
    return Core;
}());
exports.ExportExcelCore = new Core();
//# sourceMappingURL=services-export-excel.service.js.map